/**
 * 混成集計（詳細）画面 コントローラ
 */
APP.controller('KonseiResultCtrl', function($http, $window, $timeout) {
  
  // thisを保持（Ajax内のthisと混同を防ぐ為）
  var pthis = this;
  // HTMLファイル名取得
  var fileName = window.location.href.split('/').pop().split(".html").shift();


  /**
   * 初期処理
   */
  pthis.Initialize = function () {

    // 表示用データをクリア
    pthis.datTaikai = [];
    pthis.datKonseiShukei = [];
    pthis.datRekidaiKiroku = undefined;
    pthis.datRekidaiKirokuDetails = undefined;


    // Promiseを使用しJSONを並列取得し、表示処理を実施する
    Promise.all([new Promise(function (resolve, reject) {

      //=== 大会情報JSONの取得を行う
      $http({
        method  : AJAX_METHOD_GET,
        url     : '../../Taikai.json' + '?a=' + START_TIMESTAMP,
      }).then(function successCallback(response) {
        // 大会情報データ
        pthis.datTaikai = response.data;
        resolve();
      }, function errorCallback(response) {
        reject();
      });

    }), new Promise(function (resolve, reject) {

      //=== 混成集計（詳細）画面 一覧JSONの取得を行う
      $http({
        method  : AJAX_METHOD_GET,
        url     : './'+fileName+'.json' + '?a=' + START_TIMESTAMP,
      }).then(function successCallback(response) {
        // 全混成集計（詳細）データ
        pthis.datKonseiShukei = response.data;
        resolve();
      }, function errorCallback(response) {
        reject();
      });

    })]).then(function () {

      //=== 歴代記録ダイアログ用JSONを取得
      $http({
        method  : AJAX_METHOD_GET,
        url     : '../../rekidai/RekidaiKirokuKonsei.json' + '?a=' + START_TIMESTAMP,
      }).then(function successCallback(response) {
        var RekidaiKirokuKey = pthis.datKonseiShukei.KyogiNo + "-" + pthis.datKonseiShukei.SubNo;
        // 全歴代記録データ
        pthis.datRekidaiKiroku = response.data.RekidaiKirokuList[RekidaiKirokuKey];
      }, function errorCallback(response) {
        // JSON取得エラー
      });
        
    }).catch(function () {
      // JSON取得エラー
    });

  };

  /**
   * 歴代記録ボタンクリックイベント
   */
  pthis.ShowRekidai = function () {

    // 歴代記録ダイアログを表示する
    if (!!pthis.datRekidaiKiroku) {
      RekidaiDialogShow();
    }

  }

  /**
   * 歴代記録行クリックイベント
   */
  pthis.ShowRekidaiDetail = function (Details) {

    // 引数を歴代記録詳細データに設定する
    pthis.datRekidaiKirokuDetails = Details;

    // 歴代記録詳細ダイアログを表示する
    if (!!pthis.datRekidaiKirokuDetails) {
      RekidaiDetailDialogShow();
    }

  }


  // 初期処理を実行
  pthis.Initialize();

});
